/*
 *  H8 Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

/*
 *	3069.S -- depend H8/3069F
 */

#include "3069.h"
#include "comdefs.h"
#include "mondefs.h"
#include "h8mon.h"

		.h8300h

		.text
		.align		2

/*
 *	Optional Initialize
 */

_BeforeInit:
		mov.b		#0xff, r0h
		mov.b		r0h, @IOREG_P1DDR	/* Enable A0  - A7  */
		mov.b		r0h, @IOREG_P2DDR	/* Enable A8  - A15 */
		mov.b		r0h, @IOREG_P3DDR	/* Enable D8  - D15 */
		mov.b		#P5DDR_A16, r0h		/* Enable A16 */
		mov.b		r0h, @IOREG_P5DDR
		mov.b		#P8DDR_CS1 | P8DDR_CS2, r0h
		mov.b		r0h, @IOREG_P8DDR	/* Enable CS1 - CS2	*/

		mov.b		#PBDDR_UCAS, r0h
		mov.b		r0h, @IOREG_PBDDR	/* Enable Upper CAS	*/
				/* DRAM: 2,048/32ms: 32ms / 2,048 = 15.625us	*/
				/* 20MHz / 8 / 39 = 1 / 15.6us			*/
		mov.b		#(32*(CLOCK_RATE/1000))/(8*2048), r0h
		mov.b		r0h, @IOREG_RTCOR
		mov.b		#RTMCSR_CKS1, r0h
		mov.b		r0h, @IOREG_RTMCSR	/* clock / 8		*/
		mov.b		#DRCRB_RCYCE | DRCRB_MXC1, r0h
		mov.b		r0h, @IOREG_DRCRB	/* CA: 10 bit, A23-A10	*/
		mov.b		#DRCRA_BE | DRCRA_DRAS0, r0h
		mov.b		r0h, @IOREG_DRCRA	/* Enable Upper CAS	*/

		mov.l		#CLOCK_RATE/1000, er0	/* Wait for DRAM stable	*/
BeforeInit1:
		dec.l		#1, er0
		bne		BeforeInit1

		rts

/*
 *	Monitor Vector Area
 */

		.section	.monvec
		.align		4

_MonitorVector:

		.long		_Main			/*  0, 0x0000: reset */
		.long		0			/*  1, 0x0004: reserved */
		.long		0			/*  2, 0x0008: reserved */
		.long		0			/*  3, 0x000c: reserved */
		.long		0			/*  4, 0x0010: reserved */
		.long		0			/*  5, 0x0014: reserved */
		.long		0			/*  6, 0x0018: reserved */
		.long		0			/*  7, 0x001c: NMI */
		.long		0			/*  8, 0x0020: trap */
		.long		0			/*  9, 0x0024: trap */
		.long		0			/* 10, 0x0028: trap */
		.long		0			/* 11, 0x002c: trap */
		.long		0			/* 12, 0x0030: IRQ0 */
		.long		0			/* 13, 0x0034: IRQ1 */
		.long		0			/* 14, 0x0038: IRQ2 */
		.long		0			/* 15, 0x003c: IRQ3 */
		.long		0			/* 16, 0x0040: IRQ4 */
		.long		0			/* 17, 0x0044: IRQ5 */
		.long		0			/* 18, 0x0048: reserved */
		.long		0			/* 19, 0x004c: reserved */
		.long		0			/* 20, 0x0050: WOVI */
		.long		0			/* 21, 0x0054: CMI */
		.long		0			/* 22, 0x0058: reserved */
		.long		0			/* 23, 0x005c: ADI */
		.long		0			/* 24, 0x0060: IMIA0 */
		.long		0			/* 25, 0x0064: IMIB0 */
		.long		0			/* 26, 0x0068: OVI0 */
		.long		0			/* 27, 0x006c: reserved */
		.long		0			/* 28, 0x0070: IMIA1 */
		.long		0			/* 29, 0x0074: IMIB1 */
		.long		0			/* 30, 0x0078: OVI1 */
		.long		0			/* 31, 0x007c: reserved */
		.long		0			/* 32, 0x0080: IMIA2 */
		.long		0			/* 33, 0x0084: IMIB2 */
		.long		0			/* 34, 0x0088: OVI2 */
		.long		0			/* 35, 0x008c: reserved */
		.long		0			/* 36, 0x0090: CIMIA0 */
		.long		0			/* 37, 0x0094: CIMIB0 */
		.long		0			/* 38, 0x0098: CIMIA1/CIMIB1 */
		.long		0			/* 39, 0x009c: TOVI0/TOVI1 */
		.long		0			/* 40, 0x00a0: CIMIA2 */
		.long		0			/* 41, 0x00a4: CIMIA2 */
		.long		0			/* 42, 0x00a8: CIMIA3/CIMIB3 */
		.long		0			/* 43, 0x00ac: TOVI2/TOVI3 */
		.long		0			/* 44, 0x00b0: DEND0A */
		.long		0			/* 45, 0x00b4: DEND0B */
		.long		0			/* 46, 0x00b8: DEND1A */
		.long		0			/* 47, 0x00bc: DEND1B */
		.long		0			/* 48, 0x00c0: reserved */
		.long		0			/* 49, 0x00c4: reserved */
		.long		0			/* 50, 0x00c8: reserved */
		.long		0			/* 51, 0x00cc: reserved */
		.long		_InterERI0		/* 52, 0x00d0: ERI0 */
		.long		_InterRXI0		/* 53, 0x00d4: RXI0 */
		.long		_InterTXI0		/* 54, 0x00d8: TXI0 */
		.long		_InterTEI0		/* 55, 0x00dc: TEI0 */
		.long		_InterERI1		/* 56, 0x00e0: ERI1 */
		.long		_InterRXI1		/* 57, 0x00e4: RXI1 */
		.long		_InterTXI1		/* 58, 0x00e8: TXI1 */
		.long		_InterTEI1		/* 59, 0x00ec: TEI1 */

#if MAX_SERIAL >= 3

		.long		_InterERI2		/* 60, 0x00f0: ERI2 */
		.long		_InterRXI2		/* 61, 0x00f4: RXI2 */
		.long		_InterTXI2		/* 62, 0x00f8: TXI2 */
		.long		_InterTEI2		/* 63, 0x00fc: TEI2 */

#else	/* of #if MAX_SERIAL >= 3 */

		.long		0			/* 60, 0x00f0: ERI2 */
		.long		0			/* 61, 0x00f4: RXI2 */
		.long		0			/* 62, 0x00f8: TXI2 */
		.long		0			/* 63, 0x00fc: TEI2 */

#endif	/* of #if MAX_SERIAL >= 3 */

		.end
